        LIST P=16F628, R=DEC    ; Use the PIC16F628 and decimal system 

        #include "P16F628.INC"  ; Include header file 

        __config  _XT_OSC &_LVP_OFF & _WDT_OFF & _PWRTE_ON & _BODEN_ON & _MCLRE_OFF

         
;***************************************************************************************
;Rutina koduje text a tel. cislo do PDU formatu SMS a vysila do telefonu	           * 
; 																					   *
;autor: Dave Hankovec - DH servis  http://home.tiscali.cz/dh_servis  				   *
;mailto:	david.hankovec@tiscali.cz												   *
;date:	january 2004																   *
;																					   *
;Implementuje tel. cislo z telefonu (SIM), pozice zadana v promenne "pozice_tel".      *
;odesila SMS, ktera je ulozena v RAM procesoru. Musi byt ulozena v ASCII kodu,	 	   *	
;umisteni v pameti je relativne libovolne, ale musi byt v bance 0, a text SMS musi	   *
; byt ukoncen cislem 0FFH.														 	   *
;												   									   *
;		TOTO JE POUZE PRIKLAD,SPOCTE PDU JEDNE SMS,ODESLE NA CISLO V TABULCE A SKONCI  * 							   *
;***************************************************************************************


;Vsechny adresy je mozno zmenit, i adresu RAM1, to je pocatecni adresa pro indirect adresovani
;od teto adresy (zde 2BH) je alokovano dalsich 12 byte, ktere se budou prepisovat !!

pocet_znaku	equ	20H		;pocet znaku v SMS, je zadavano v hexa, je to cislo mezi tel.cislem a PDU SMS, je to v hexa 
PointH	equ	21H			;tabulka
PointL	equ	22H			;tabulka
TMP		equ	23H
octets	equ	24H			;pocet oktetu celeho ramce PDU - POZOR DECIMALNE
TMP1	equ	25H
stovky		equ	26H		;prevedena data 
desitky 	equ	27H		;prevedena data
cas0		equ	28H		;pro casovaci smycku
cas1		equ	29H
cas2		equ	2AH
cislo_SMS	equ	2BH		;cislo SMS v seznamu
pozice_tel	equ	2CH		;pozice tel.cisla na SIM v telefonu, na ktere se ma SMS odeslat

	constant	ram1=2DH	;POZOR, indirect adressing, od teto adresy je alokovano 12 byte (vcetne) ktere budou PREPISOVANY !!
	constant	SMS=ram1+12D		;zacatek SMS v RAM, ukoncena musi byt bytem s cislem 0FFH, zadavane musi byt znaky v ASCII (napr. a=61H)!!
							;MUSITE si ohlidat, aby alokovana pamet byla v bance 0, data musi nasledovat za sebou
							;pokud menite adresy, musi byt odstup mezi adresami "ram1" a "SMS" 12 byte !!!
	org	0


;delka textu SMS muze byt promenna, jen musi byt vzdy ukoncen znakem 0FFH, rutiny si vse potrebne spocitaji sami 
;toto obsazeni RAM zpravou je jen priklad, pocatecni adresa je nastavena v konstante SMS, dale jsou data
;ukladana postupne, ukonceni 0FFH
	movlw	SMS
	movwf	FSR
	movlw	'D'			
	movwf	INDF

	movlw	SMS+1
	movwf	FSR
	movlw	'H'
	movwf	INDF

	movlw	SMS+2
	movwf	FSR
	movlw	' ' 
	movwf	INDF

	movlw	SMS+3
	movwf	FSR
	movlw	's'
	movwf	INDF

	movlw	SMS+4
	movwf	FSR
	movlw	'e'
	movwf	INDF

	movlw	SMS+5
	movwf	FSR
	movlw	'r'
	movwf	INDF

	movlw	SMS+6
	movwf	FSR
	movlw	'v'
	movwf	INDF

	movlw	SMS+7
	movwf	FSR
	movlw	'i'
	movwf	INDF

	movlw	SMS+8
	movwf	FSR
	movlw	's'
	movwf	INDF

	movlw	SMS+9
	movwf	FSR
	movlw	' '
	movwf	INDF

	movlw	SMS+10
	movwf	FSR
	movlw	'S'
	movwf	INDF

	movlw	SMS+11
	movwf	FSR
	movlw	'M'
	movwf	INDF

	movlw	SMS+12
	movwf	FSR
	movlw	'S'
	movwf	INDF
	
	movlw	SMS+13
	movwf	FSR
	movlw	0FFH
	movwf	INDF
;------------------------------KONEC DAT PRO PRIKLAD---------------------------------   	

	movlw 7
	movwf CMCON		; CMCON=7 set comperators off         
; 
; ---------------- 
; INITIALIZE PORTS
; ---------------- 
; 
		movlw b'00000000'       ; set up portA
        movwf PORTA	
        
        movlw b'00000100'	; RB2(TX)=1 others are 0
        movwf PORTB

        bsf STATUS,RP0          ; RAM PAGE 1

        movlw 0F0H
        movwf TRISA		; portA all pins input

        movlw b'11110010'	; RB7-RB4 and RB1(RX)=input, others output 
        movwf TRISB

; ------------------------------------
; SET BAUD RATE TO COMMUNICATE WITH PC
; ------------------------------------
; Boot Baud Rate = 9600, No Parity, 1 Stop Bit
;
        movlw 0x0C              ; 0x19=9600 bps (0x0C=19200 bps)
        movwf SPBRG
        movlw b'00100100'       ; brgh = high (2)
        movwf TXSTA             ; enable Async Transmission, set brgh

        bcf STATUS,RP0          ; RAM PAGE 0

        movlw b'10010000'       ; enable Async Reception
        movwf RCSTA

 
	bcf	STATUS,RP0
  	clrf	pocet_znaku

  ;==================================KOMPLET============================= 	
;promenne cislo_SMS a pozice_tel si muzete nastavit ve svem programu samozrejme jinak 
;je pocet SMS musi odpovidat poctu tabulek
	call	cekame_1
	call	vypocty			;Nejprve se vypocte delka celeho ramce PDU a pocet znaku textu SMS
	movlw	01H				;zadej pozici tel. cisla na SIM,na ktere se SMS posle. Cislo pozice je v HEXA
	movwf	pozice_tel		;pokud budete volat ze sveho softu, toto cislo samozrejme zadate do promenne tam
	call	vycti_cislo		;cislo z pozice v promenne "pozice_tel" je presunuto z MT do RAM
	call	cekame_1
	call	prikazCMGF		;AT+CMGF=0 <cr>		- Format dat bude PDU
	call	cekame_1
	call	prikazCMGS		;AT+CMGS= pocet oktetu <cr>
	call	cekame_1
	call	hlavicka		;popis v subrutine
	call	posli_cislo		;popis v subrutine
	call	posli_delku
	call	posli_text
	call	cekame_1
	call	ukonci			;pokud chcete jen test pres seriovou linku, zmente hodnotu v rutine 1AH coz je odeslani SMS na 1BH, coz je ESCAPE
 	goto	$
 ;===============================KONEC==================================


;-----------------Posle delku textu SMS (pocet znaku), je to v hexa---------- 
posli_delku 
	movlw	4D		;posli 4x0, pak 2 cifry delku, celek pak vypada napr. 00 00 0B 
	movwf	TMP
pokr_07
	movlw	'0'
	call	send
	decfsz	TMP,F
	goto	pokr_07
	movf	pocet_znaku,W
send_ascii
	call	hex2ascii
	movwf	TMP1			;uschovej low byte
	movf	TMP,W			;nacti vyssi
	call	send			;posli ho
	movf	TMP1,W			;nacti nizsi zpet
	call	send			;posli ho
	return
;----------------------------------------------------------------------------	
  					
;----------------------------------------------------------------------------	  
vypocty
	movlw	SMS			;nacti zacatek SMS v RAM
	movwf	FSR
	goto	zacatek
pokr_01
	incf	FSR,F			;zvys index ukazujici v RAM
	incf 	pocet_znaku,f
zacatek
	movf	INDF,W		; nacten polozky z tabulky 
  	sublw 0FFH
  	btfss	STATUS,Z	;jsem na konci dat SMS ? zero=ano
  	goto	pokr_01
    	
 ;----ted se vypocte pocet oktetu------
 ;vezme se pocet vsech znaku SMS, vydeli se 8 a celociselny zustatek se odecte od poctu znaku
 ;vysledek je pocet oktetu samotne SMS (ten se jediny meni podle delky SMS). K tomu je treba pripocitat pocet oktetu 
 ;hlavicky, telefonniho cisla atd. Celkovy vysledek je potom vysilan telefonu jako parametr prikazu CMGS

	movf	pocet_znaku,W		;nacti pocet znaku SMS
	movwf	TMP
	bcf		STATUS,C		;nuluj CY pro rotaci
	rrf		TMP,F			;rotuj W cili del cislo 2	
	bcf		STATUS,C		;nuluj CY pro rotaci
	rrf		TMP,F				;rotuj W cili del cislo 2
	bcf		STATUS,C		;nuluj CY pro rotaci
	rrf		TMP,F				;rotuj W cili del cislo 2
							;celkem teda mame v TMP cislo vydelene 8 (2x2x2)

	movf	TMP,W			;presun vysledek pro odecet
	subwf	pocet_znaku,W	;odecti vysledek deleni od poctu znaku a uloz do W, vysledek je pocet oktetu textu SMS po prevedeni do PDU
	addlw	4+6+3			;secti oktety (hlavicka=(typ cisla a delka t.j.4byte)+tel.cislo t.j.12byte + udana delka textu SMS 3byte + vlastni SMS)
	movwf	octets			;a uloz
	return
;----------------------------------------------------------------------------	
  	
;-------------Cteni textu SMS-----------------
;nacti 8 byte z tabulky do RAM
;po nacteni se vzdy provede rotace doleva, protoze 8. bit je v ascii neplatny
;a pri rotaci doprava by byl spatne
posli_text


	movlw	4+6+3	;odecte hlavicku atd. viz vyse od celkove delky
	subwf	octets,F	;a tim se zjisti, kolik byte se bude vysilat 
	movlw	SMS-1			;nacti adresu prvniho zaznamu (index)
	movwf	ram1+11		;uschovej
pokr_03
	call	nuluj_ram
	movlw	ram1-1
	movwf	ram1+10
	movlw	8D
	movwf	TMP
	bcf		STATUS,C
pokr_04						;promenne nad 8 byte ram1+9,10,11 a 12 jiz nepotrebuji (pouze pro tel. cislo), zde pouzity jako docasne promenne 
	incf	ram1+10,F		;inkrementuj index upravenych dat
	incf	ram1+11,F		;inkrementuj index uzivatelskych dat - textu SMS
	movf	ram1+11,W		;nacti index dat
	movwf	FSR				;prejdi na adresu
	movf	INDF,W			;cti obsah
 	movwf	ram1+9			;uschovej
 	rlf		ram1+9,F		;uprav vysledek pro prevod do PDU
	movf	ram1+10,W		;nacti index adresy upravenych dat
	movwf	FSR				;prejdi na adresu
	movf	ram1+9,W
	movwf	INDF
	decfsz	pocet_znaku,F	;testuj konec
	goto	pokr_05
	goto	nacteno
pokr_05
	decfsz	TMP,F		;nacti vzdy jen 8 znaku a hned je rotuje 
	goto	pokr_04		;nenacteno 8 znaku, opakuj
nacteno
	movlw	ram1+7		;vrat spravnou hodnotu 8 byte, ten se nerotuje
	movwf	FSR
	rrf		INDF,F
;--------------data nactena----------------------
	
	bcf	STATUS,C
	movlw	2
	call	pokr_08
	movlw	3
	call	pokr_08
	movlw	4
	call	pokr_08
	movlw	5
	call	pokr_08
	movlw	6
	call	pokr_08
	movlw	7
	call	pokr_08
	movlw	8
	call	pokr_08
	goto 	pokr_11
	
pokr_08
	movwf	TMP			
	movlw	ram1+8		;adresuj 8. byte v RAM
	movwf	FSR
pokr_09
	decf	FSR,F
	rrf	INDF,F			;rotuj 8. byte
	decfsz	TMP,F
	goto	pokr_09
	return
;PDU 8 byte hotovo
;posli data ram1 az 7, 8 byte je prazdny nevysila se, misto nej prijde 1. byte dalsich 8 kodovanych byte
;aby se zjistilo, kolik se toho ma poslat,decrementuje se promenna octets a pri dosazeni 0 se vysilani ukonci
pokr_11
	movlw	ram1
	movwf	FSR
pokr_10	
	movf	INDF,W
	call	send_ascii		;preved hexa na ascii
	decf	octets,F		;test dosazeni konce dat
	btfsc	STATUS,Z
	return
	incf	FSR,F
	movlw	ram1+7
	xorwf	FSR,W
	btfss	STATUS,Z			;testuj vyslani 7.byte (po vyslani 7. a incf na osmy je nastaven 00001000 3.bit FSR)
	goto	pokr_10
	goto	pokr_03			;vyslano, nacti dalsi byte a proved convert PDU
;----------------------------------------------------------------------------------	
nuluj_ram
 	movlw	ram1-1
	movwf	FSR
smaz
 	incf	FSR,F
  	movlw	0
 	movwf	INDF
 	movlw	ram1+7
 	xorwf	FSR,W
	btfss	STATUS,Z
 	goto	smaz	
 	return
	
;------------------------------Vysle hlavicku 0001000C91--------
;cely format PDU pro SMS na tel. cislo 420603123456 s textem DH servis 0001000C91 2460302143650000094424685E96DBD373
;hlavicka je oddelena mezerou (samozrejme jen zde)
;0C je pocet cifer tel.cisla, 91=mezinarodni kod tel. cisla
;hlavicka s cislem ma 10 oktetu, decimalne
hlavicka
	movlw	3
	movwf	TMP	
opakuj
	movlw	'0'			;posle 3x'0'
	call	send
	decfsz	TMP,F
	goto	opakuj
	movlw	'1'			;posle '1'
	call	send
	movlw	3			
	movwf	TMP	
opakuj1
	movlw	'0'			;posle 3x'0'
	call	send
	decfsz	TMP,F
	goto	opakuj1
	movlw	'C'			;posle 'C'
	call	send
	movlw	'9'			;posle '9'
	call	send
	movlw	'1'			;posle '1'
	call	send
	return
;-------------------------------------------------------------

;---------------------------Nacte cislo z RAM (12 znaku) do promennych a pak je posle na UART ve zmenenem poradi dle formatu PDU-----
posli_cislo
	;cislo mam ulozene v RAM1 az 12, postupne. RAM1=4 (prvni), RAM12=6(posledni).
	;Pozice se vysilaji v tomto poradi (cisla jsou cisla cifer tel. cisla) 2.cifra,1.cifra,4.,3.,6.,5.,8.,7.,10.,9.,12.,11.

	movlw	ram1+1
	call	odesli
	movlw	ram1
	call	odesli
	movlw	ram1+3
	call	odesli
	movlw	ram1+2
	call	odesli
	movlw	ram1+5
	call	odesli
	movlw	ram1+4
	call	odesli
	movlw	ram1+7
	call	odesli
	movlw	ram1+6
	call	odesli
	movlw	ram1+9
	call	odesli
	movlw	ram1+8
	call	odesli
	movlw	ram1+11
	call	odesli
	movlw	ram1+10
	call	odesli	
	return
	
odesli
	movwf	FSR
	movf	INDF,W
	call	send
	return

;--------------------------------------------------------------
cti_znaky	
	movlw	ram1-1
	movwf	FSR
cti
 	incf	FSR,F
  	call 	receive
 	movwf	INDF
 	movlw	ram1+11
 	xorwf	FSR,W
	btfss	STATUS,Z
 	goto	cti	
 	return

;-----------------vycteni telef. cisla z MT --------------------
;posli prikaz
vycti_cislo
	call prikaz_AT
	movlw 'C'
	call send
	movlw 'P'
	call send
	movlw 'B'
	call send
	movlw 'R'
	call send
	movlw '='
	call send
	movf	pozice_tel,W	;podle cisla v promenne nacte cislo z pozice na SIM,pozor pri ladeni, cislo je vzdy v HEXA
	call	bin2dec
	movf	desitky,W
	call	send_ascii		; a zadavani cisla - cislo musi byt v ASCII
	movlw 0DH		;ENTER
	call send
;---cti data z MT---------------------
pokr_13
	call receive			;cti jeden znak
	bcf STATUS,Z
	sublw 	'"'				;testuj dosazeni ASCII znaku uvozovek,pokud nejsou,cti znovu seriak
	btfss STATUS,Z
	goto pokr_13
	movlw 1H					;prisly uvozovky,zacina tlf. cislo,zadej do W
	call orizni					;precte znak + a zahodi ho,bude pridan pri volani cisla
	call cti_znaky				;precte 12 znaku ze seriaku
	call cekame					;odcasuje
	return


;-------Nacte a zahodi pocet znaku ze seriaku podle cisla v W, vysledek je ve W-----------------------------------------------------
orizni	movwf TMP
pokr_12	call receive	;nacti znak z MT
	decfsz TMP,f			
	goto pokr_12
	return
;------------------------------------------------------------



;-----------posle prikaz AT+ -----------------------
prikaz_AT	
	movlw 'A'
	call send
	movlw 'T'
	call send
	movlw '+'
	call send
	return
;---------------------------------------------------
;-----------------------------Pozadavek odeslani SMS ve formatu PDU a jako parametr prida delku celeho PDU------------
;parametr prikazu je delka PDU
prikazCMGS
	call	prikaz_AT
	movlw	'c'
	call	send
	movlw	'm'
	call	send
	movlw	'g'
	call	send
	movlw	's'
	call	send
	movlw	'='
	call	send
	movf	octets,W
	call	bin2dec		;prevedeni do desitkove soustavy
	movf	desitky,W
	call	hex2ascii
	movwf	TMP1			;uschovej low byte
	movf	TMP,W			;nacti vyssi
	call	send			;posli ho
	movf	TMP1,W			;nacti nizsi zpet
	call	send			;posli ho
	movlw	0DH		;ENTER
	call	send
	return
;-------------------------------


;-----------------------------Ukoncujici prikaz (CTRL Z)----------
ukonci
	movlw	1AH				;pokud chcete jen test pres seriovou linku, zmente hodnotu 1AH coz je odeslani SMS na 1BH, coz je ESCAPE
	call	send
	return
;-----------------------------------------------------------------

;-----------------------------Format dat bude PDU------------
prikazCMGF
	call	prikaz_AT
	movlw	'c'
	call	send
	movlw	'm'
	call	send
	movlw	'g'
	call	send
	movlw	'f'
	call	send
	movlw	'='
	call	send
	movlw	'0'
	call	send
	movlw	0DH		;ENTER
	call	send
	return
;-------------------------------

;-------------------------------Prevede 1 byte hexa do dec-----------------
bin2dec
	clrf     TMP
	clrf	stovky
	clrf	desitky
opet_1
	addlw    -64H
	btfss     STATUS,C
	goto	dalsi_rad
	incf		stovky, F
	goto	opet_1
dalsi_rad
	addlw    100
opet
	addlw    -10
	btfss     STATUS,C
	goto    swapTMP
	incf     desitky, F
	goto    opet
swapTMP
	addlw    10
	swapf    desitky, F
	iorwf     desitky, F
	return
;---------------------------------------------------------------------------------------------
;vraci vyssi v TMP, nizsi ve W - bacha na zasobnik !!
hex2ascii
        MOVWF   TMP ; save byte temporarily
        SWAPF   TMP,W       
        ; convert top nibble
        CALL    CONV_NIBBLE_HEX 
        ; top nibble in w, exchange char_hi with w
        XORWF   TMP,F
        XORWF   TMP,W
        XORWF   TMP,F
        ; and convert low nibble
CONV_NIBBLE_HEX
        ANDLW   0x0F    ; mask out top nibble, preserv low nibble
        ADDLW   0xF6    ; add 246, to check if 0-9 or a-f, w=nibble+246
        BTFSC   STATUS,C ; if carry set then a-f
        ADDLW   0x07     ; carry set, then add 7, w=nibble+246+7 ( note nibble known to be a-f )
        ADDLW   0x3A     ; then finally add 58 to get 'proper' ascii 
                        ; 1) w = low(nibble+246+58) = 48+nibble ( if 0-9 )
                        ; 2) w = low(nibble+246+7+58) = 55+nibble ( if a-f )
        ; nibble converted to ASCII hex in w            
        RETURN
; -------------------------Vysle data ve W na UART------------------------------------
send	movwf TXREG             ; send data in W 
TransWt bsf STATUS,RP0		; RAM PAGE 1
WtHere  btfss TXSTA,TRMT        ; (1) transmission is complete if hi
        goto WtHere

        bcf STATUS,RP0          ; RAM PAGE 0
        return
; -------------------------Prijme data z UARTu-------------------------------
receive 
	BCF		STATUS,RP0
	BTFSS	RCSTA,OERR
	GOTO	$+3
	BCF RCSTA,CREN
	BSF RCSTA,CREN
	BTFSS PIR1,RCIF
	GOTO $-1
	MOVF RCREG,W
	RETURN


;---------------casovaci rutina-----150 msec.--------------------------------
cekame	;Variables: TMP1, TMP0
;Delay 149996 cycles
       	clrwdt
        MOVLW 0x0E5  ;229 DEC
        MOVWF cas1
        MOVLW 0x0D9  ;217 DEC
        MOVWF cas0
        DECFSZ cas0,F
        GOTO $-1
        DECFSZ cas1,F
        GOTO $-5
;End of Delay
	return

;------------------casovaci rutina---------1 sec.
cekame_1	
;Delay 1000000 cycles
        MOVLW 0x15  ;21 DEC
        MOVWF cas2
        MOVLW 0x59  ;89 DEC
        MOVWF cas1
        MOVLW 0x0B1  ;177 DEC
        MOVWF cas0
        DECFSZ cas0,F
        GOTO $-1
        DECFSZ cas1,F
        GOTO $-5
        DECFSZ cas2,F
        GOTO $-9
		return
  
        END

