
        LIST P=16F628, R=DEC    ; Use the PIC16F628 and decimal system 

        #include "P16F628.INC"  ; Include header file 

        __config  _XT_OSC &_LVP_OFF & _WDT_OFF & _PWRTE_ON & _BODEN_ON & _MCLRE_OFF

         
;***************************************************************************************
;Rutina koduje text a tel. cislo do PDU formatu SMS a vysila do telefonu	           * 
; 																					   *
;autor: Dave Hankovec - DH servis  http://home.tiscali.cz/dh_servis  				   *
;mailto:	david.hankovec@tiscali.cz												   *
;date:	january 2004																   *
;																					   *
;Implementuje tel. cislo z tabulky a text SMS v druhe radce. Text SMS musi byt		   *
;ukoncen cislem 0FFH. Rutina pocita kompletni PDU format,							   *
;a implementuje tel.cislo do PDU a vysle do mobilniho telefonu (SIEMENS C35I)		   *
;		TOTO JE POUZE PRIKLAD,SPOCTE PDU JEDNE SMS,ODESLE NA CISLO V TABULCE A SKONCI  * 							   *
;***************************************************************************************




pocet_znaku	equ	27H	;- znaku v SMS, je zadavano v hexa, je to cislo mezi tel.cislem a PDU SMS, je to v hexa 
PointH	equ	28H
PointL	equ	29H
TMP		equ	2AH
octets	equ	2BH		;pocet oktetu celeho ramce PDU - POZOR DECIMALNE
TMP1	equ	2CH

ram1	equ	2EH
ram2	equ	2FH
ram3	equ	30H
ram4	equ	31H
ram5	equ	32H
ram6	equ	33H
ram7	equ	34H
ram8	equ	35H
;---------------Tyto promenne jsou pouzity jen pro cislo
ram9	equ	36H
ram10	equ	37H
ram11	equ	38H
ram12	equ	39H
stovky		equ	3AH
desitky 	equ	3BH
cas0		equ	3CH
cas1		equ	3DH
cas2		equ	3EH

	constant	table_sms=0DH		;prvni polozka tabulky SMS
	constant	table_number=01H

	org	0
	goto init


;delka textu SMS muze byt promenna, jen musi byt vzdy ukoncen znakem 0FFH, rutiny si vse potrebne spocitaji samy 
Table
	dt '4','2','0','6','0','6','1','2','3','4','5','6'					;telefonni cislo
  dt 'D','H',' ','s','e','r','v','i','s',0FFH					;SMS text


      						;*** procedura pro nacten hodnoty z tabulky 
GetTab
	movf PointH,W 			; nacten ukazatele HIGH do W 
 	movwf PCLATH 			; nastaven adresy skoku HIGH 
 	movf PointL,W			; nacten ukazatele LOW do W 
 	incf PointL,F 			; zven ukazatele LOW 
 	btfsc STATUS,Z 			; je pretecen ukazatele LOW pres 0? 
  	incf PointH,F 			; pri pretecen zven ukazatele HIGH 
  	movwf PCL 				; zpis W do PCL = skok do tabulky 
      
      
init 

	movlw 7
	movwf CMCON		; CMCON=7 set comperators off         
; 
; ---------------- 
; INITIALIZE PORTS
; ---------------- 
; 
	movlw b'00000000'       ; set up portA
        movwf PORTA	
        
        movlw b'00000100'	; RB2(TX)=1 others are 0
        movwf PORTB

        bsf STATUS,RP0          ; RAM PAGE 1

        movlw 0F0H
        movwf TRISA		; portA all pins input

        movlw b'11110010'	; RB7-RB4 and RB1(RX)=input, others output 
        movwf TRISB

; ------------------------------------
; SET BAUD RATE TO COMMUNICATE WITH PC
; ------------------------------------
; Boot Baud Rate = 9600, No Parity, 1 Stop Bit
;
        movlw 0x0C              ; 0x19=9600 bps (0x0C=19200 bps)
        movwf SPBRG
        movlw b'00100100'       ; brgh = high (2)
        movwf TXSTA             ; enable Async Transmission, set brgh

        bcf STATUS,RP0          ; RAM PAGE 0

        movlw b'10010000'       ; enable Async Reception
        movwf RCSTA

 
	bcf	STATUS,RP0


;*** inicializace ukazatele tabulky 
	movlw HIGH Table ; adresa tabulky HIGH do W 
  	movwf PointH ; nastaven ukazatele HIGH 
  	movlw LOW Table ; adresa tabulky LOW do W 
  	movwf PointL ; nastaven ukazatele LOW 
  	clrf	pocet_znaku

  ;==================================KOMPLET============================= 	
	call	vypocty			;Nejprve se vypocte delka celeho ramce PDU a pocet znaku textu SMS
	call	cekame_1
	call	prikazCMGF		;AT+CMGF=0 <cr>		- Format dat bude PDU
	call	cekame_1
	call	prikazCMGS		;AT+CMGS= pocet oktetu <cr>
	call	cekame_1
	call	hlavicka		;popis v subrutine
	call	posli_cislo		;popis v subrutine
 	call	posli_delku
 	call	posli_text
 	call	cekame_1
 	call	ukonci
 	goto	$
 
;-----------------Posle delku textu SMS (pocet znaku), je to v hexa---------- 
posli_delku 
	movlw	'0'
	call	send
	movlw	'0'
	call	send
	movlw	'0'
	call	send
	movlw	'0'
	call	send
	movf	pocet_znaku,W
	call	hex2ascii
	movwf	TMP1			;uschovej low byte
	movf	TMP,W			;nacti vyssi
	call	send			;posli ho
	movf	TMP1,W			;nacti nizsi zpet
	call	send			;posli ho
	return
;----------------------------------------------------------------------------	
  					
;----------------------------------------------------------------------------	  
vypocty
	movlw	table_sms		;nastav zacatek SMS tabulky
	movwf	 PointL
	goto	zacatek
pokr_01
	incf 	pocet_znaku,f
zacatek
	call GetTab			; naten polozky z tabulky 
  	sublw 0FFH
  	btfss	STATUS,Z	;jsem na konci dat SMS ? zero=ano
  	goto	pokr_01
  	clrf 	PCLATH 		; nulovn adresy skok HIGH 
  	
 ;----ted se vypocte pocet oktetu------
 ;vezme se pocet vsech znaku SMS, vydeli se 8 a celociselny zustatek se odecte od poctu znaku
 ;vysledek je pocet oktetu samotne SMS (ten se jediny meni podle delky SMS). K tomu je treba pripocitat pocet oktetu 
 ;hlavicky, telefonniho cisla atd. Celkovy vysledek je potom vysilan telefonu jako parametr prikazu CMGS

	movf	pocet_znaku,W		;nacti pocet znaku SMS
	movwf	TMP
	bcf		STATUS,C		;nuluj CY pro rotaci
	rrf		TMP,F			;rotuj W cili del cislo 2	
	bcf		STATUS,C		;nuluj CY pro rotaci
	rrf		TMP,F				;rotuj W cili del cislo 2
	bcf		STATUS,C		;nuluj CY pro rotaci
	rrf		TMP,F				;rotuj W cili del cislo 2
							;celkem teda mame v TMP cislo vydelene 8 (2x2x2)

	movf	TMP,W			;presun vysledek pro odecet
	subwf	pocet_znaku,W	;odecti vysledek deleni od poctu znaku a uloz do W, vysledek je pocet oktetu textu SMS po prevedeni do PDU
	addlw	4+6+3			;secti oktety (hlavicka=(typ cisla a delka t.j.4byte)+tel.cislo t.j.12byte + udana delka textu SMS 3byte + vlastni SMS)
	movwf	octets			;a uloz
							;jeste prevest do desitkove soustavy

	return
;----------------------------------------------------------------------------	
  	
 
 
  	
;-------------Prvni polozka SMS-----------------
;nacti 8 byte z tabulky do RAM
;po nacteni se vzdy provede rotace doleva, protoze 8. bit je v ascii neplatny
;a pri rotaci doprava by byl spatne
posli_text
	
	movlw	4+6+3	;odecte hlavicku atd. viz vyse od celkove delky
	subwf	octets,F	;a tim se zjisti, kolik byte se bude vysilat 


	movlw	table_sms
	movwf	 PointL
pokr_03
	call	nuluj_ram
;-----------
	call GetTab 	; nacten polozky z tabulky
	movwf	ram1	;ulozeni polozky
	rlf		ram1,F	;posun doleva pro upravu
	decfsz	pocet_znaku,F
	goto	dalsi_polozka1
	goto	nacteno
;-----------	
dalsi_polozka1
	call GetTab 	;nacten polozky z tabulky
	movwf	ram2	;ulozeni polozky
	rlf		ram2,F
	decfsz	pocet_znaku,F
	goto	dalsi_polozka2
	goto	nacteno
;-----------	
dalsi_polozka2
	call GetTab		; nacten polozky z tabulky
	movwf	ram3	;ulozeni polozky
	rlf		ram3,F
	decfsz	pocet_znaku,F
	goto	dalsi_polozka3
	goto	nacteno
;-----------	
dalsi_polozka3
	call GetTab 	; nacten polozky z tabulky
	movwf	ram4	;ulozeni polozky
	rlf		ram4,F
	decfsz	pocet_znaku,F
	goto	dalsi_polozka4
	goto	nacteno
;-----------	
dalsi_polozka4
	call GetTab 	; nacten polozky z tabulky
	movwf	ram5	;ulozeni polozky
	rlf		ram5,F
	decfsz	pocet_znaku,F
	goto	dalsi_polozka5
	goto	nacteno
;-----------	
dalsi_polozka5
	call GetTab 	; nacten polozky z tabulky
	movwf	ram6	;ulozeni polozky
	rlf		ram6,F
	decfsz	pocet_znaku,F
	goto	dalsi_polozka6
	goto	nacteno
;-----------	
dalsi_polozka6
	call GetTab 	; nacten polozky z tabulky
	movwf	ram7	;ulozeni polozky
	rlf		ram7,F
	decfsz	pocet_znaku,F
	goto	dalsi_polozka7
	goto	nacteno
;-----------	
dalsi_polozka7
	call GetTab 	; nacten polozky z tabulky
	movwf	ram8	;ulozeni polozky
	decf	pocet_znaku,F
;--------------data nactena----------------------
nacteno
	bsf		STATUS,C	
	clrf	TMP

pokr_02
	rlf	TMP,F
	bcf	STATUS,C
	rrf	ram8,F
	rrf	ram7,F
	btfsc	TMP,0
	goto	pokr_02
	rrf	ram6,F
	btfsc	TMP,1
	goto	pokr_02
	rrf	ram5,F
	btfsc	TMP,2
	goto	pokr_02
	rrf	ram4,F
	btfsc	TMP,3
	goto	pokr_02
	rrf	ram3,F
	btfsc	TMP,4
	goto	pokr_02
	rrf	ram2,F
	btfsc	TMP,5
	goto	pokr_02
	rrf	ram1,F
;PDU 8 byte hotovo


;posli data ram1 az 7, 8 byte je prazdny nevysila se, misto nej prijde 1. byte dalsich 8 kodovanych byte
;aby se zjistilo, kolik se toho ma poslat,decrementuje se promenna octets a pri dosazeni 0 se vysilani ukonci
	movf	ram1,W
	call	hex2ascii		;preved hexa na ascii
	movwf	TMP1			;uschovej low byte
	movf	TMP,W			;nacti vyssi
	call	send			;posli ho
	movf	TMP1,W			;nacti nizsi zpet
	call	send			;posli ho
	decf	octets,F		;test dosazeni konce dat
	btfsc	STATUS,Z
	return

	movf	ram2,W
	call	hex2ascii		;preved hexa na ascii
	movwf	TMP1			;uschovej low byte
	movf	TMP,W			;nacti vyssi
	call	send			;posli ho
	movf	TMP1,W			;nacti nizsi zpet
	call	send			;posli ho
	decf	octets,F		;test dosazeni konce dat
	btfsc	STATUS,Z
	return

	movf	ram3,W
	call	hex2ascii		;preved hexa na ascii
	movwf	TMP1			;uschovej low byte
	movf	TMP,W			;nacti vyssi
	call	send			;posli ho
	movf	TMP1,W			;nacti nizsi zpet
	call	send			;posli ho
	decf	octets,F		;test dosazeni konce dat
	btfsc	STATUS,Z
	return
	
	movf	ram4,W
	call	hex2ascii		;preved hexa na ascii
	movwf	TMP1			;uschovej low byte
	movf	TMP,W			;nacti vyssi
	call	send			;posli ho
	movf	TMP1,W			;nacti nizsi zpet
	call	send			;posli ho
	decf	octets,F		;test dosazeni konce dat
	btfsc	STATUS,Z
	return

	movf	ram5,W
	call	hex2ascii		;preved hexa na ascii
	movwf	TMP1			;uschovej low byte
	movf	TMP,W			;nacti vyssi
	call	send			;posli ho
	movf	TMP1,W			;nacti nizsi zpet
	call	send			;posli ho
	decf	octets,F		;test dosazeni konce dat
	btfsc	STATUS,Z
	return

	movf	ram6,W
	call	hex2ascii		;preved hexa na ascii
	movwf	TMP1			;uschovej low byte
	movf	TMP,W			;nacti vyssi
	call	send			;posli ho
	movf	TMP1,W			;nacti nizsi zpet
	call	send			;posli ho
	decf	octets,F		;test dosazeni konce dat
	btfsc	STATUS,Z
	return

	movf	ram7,W
	call	hex2ascii		;preved hexa na ascii
	movwf	TMP1			;uschovej low byte
	movf	TMP,W			;nacti vyssi
	call	send			;posli ho
	movf	TMP1,W			;nacti nizsi zpet
	call	send			;posli ho
	decf	octets,F		;test dosazeni konce dat
	btfsc	STATUS,Z
	return	
	goto	pokr_03
	
nuluj_ram
 	movlw	0H
 	movwf	ram1
 	movwf	ram2
 	movwf	ram3
 	movwf	ram4
 	movwf	ram5
 	movwf	ram6
 	movwf	ram7
 	movwf	ram8
 	return
 		
;------------------------------Vysle hlavicku 0001000C91--------
;cely format PDU pro SMS na tel. cislo 420603123456 s textem DH servis 0001000C91 2460302143650000094424685E96DBD373
;hlavicka je oddelena mezerou (samozrejme jen zde)
;0C je pocet cifer tel.cisla, 91=mezinarodni kod tel. cisla
;hlavicka s cislem ma 10 oktetu, decimalne
hlavicka
	movlw	3
	movwf	TMP	
opakuj
	movlw	'0'			;posle 3x'0'
	call	send
	decfsz	TMP,F
	goto	opakuj
	movlw	'1'			;posle '1'
	call	send
	movlw	3			
	movwf	TMP	
opakuj1
	movlw	'0'			;posle 3x'0'
	call	send
	decfsz	TMP,F
	goto	opakuj1
	movlw	'C'			;posle 'C'
	call	send
	movlw	'9'			;posle '9'
	call	send
	movlw	'1'			;posle '1'
	call	send
	return
;-------------------------------------------------------------

;---------------------------Nacte cislo z tabulky (12 znaku) do promennych a pak je posle na UART ve zmenenem poradi dle formatu PDU-----
posli_cislo
	movlw LOW Table ;nastav zacatek tabulky tel.cisla
	movwf	 PointL
	call GetTab 	; nacten polozky z tabulky
	movwf	ram1	;ulozeni polozky
	call GetTab 	; nacten polozky z tabulky
	movwf	ram2	;ulozeni polozky
	call GetTab 	; nacten polozky z tabulky
	movwf	ram3	;ulozeni polozky
	call GetTab 	; nacten polozky z tabulky
	movwf	ram4	;ulozeni polozky
	call GetTab 	; nacten polozky z tabulky
	movwf	ram5	;ulozeni polozky
	call GetTab 	; nacten polozky z tabulky
	movwf	ram6	;ulozeni polozky
	call GetTab 	; nacten polozky z tabulky
	movwf	ram7	;ulozeni polozky
	call GetTab 	; nacten polozky z tabulky
	movwf	ram8	;ulozeni polozky
	call GetTab 	; nacten polozky z tabulky
	movwf	ram9	;ulozeni polozky
	call GetTab 	; nacten polozky z tabulky
	movwf	ram10	;ulozeni polozky
	call GetTab 	; nacten polozky z tabulky
	movwf	ram11	;ulozeni polozky
	call GetTab 	; nacten polozky z tabulky
	movwf	ram12	;ulozeni polozky
;---------A ted to zkombinujem a vysleme-------------
	;zadane cislo v tabulce dt '4','2','0','6','0','3','1','2','3','4','5','6'
	;a jaky chci vysledek pro PDU - 246030214365
	;cislo mam ulozene v RAM1 az 12, postupne. RAM1=4 (prvni), RAM12=6(posledni).
	;Pozice se vysilaji v tomto poradi (cisla jsou cisla cifer tel. cisla) 2.cifra,1.cifra,4.,3.,6.,5.,8.,7.,10.,9.,12.,11.

	movf	ram2,W
	call	send
	movf	ram1,W
	call	send
	movf	ram4,W
	call	send
	movf	ram3,W
	call	send
	movf	ram6,W
	call	send
	movf	ram5,W
	call	send
	movf	ram8,W
	call	send
	movf	ram7,W
	call	send
	movf	ram10,W
	call	send
	movf	ram9,W
	call	send
	movf	ram12,W
	call	send
	movf	ram11,W
	call	send	
	return
;--------------------------------------------------------------

;-----------------------------Pozadavek odeslani SMS ve formatu PDU a jako parametr prida delku celeho PDU------------
;parametr prikazu je delka PDU
prikazCMGS
	movlw	'a'
	call	send
	movlw	't'
	call	send
	movlw	'+'
	call	send
	movlw	'c'
	call	send
	movlw	'm'
	call	send
	movlw	'g'
	call	send
	movlw	's'
	call	send
	movlw	'='
	call	send
	movf	octets,W
	call	bin2dec		;prevedeni do desitkove soustavy
	movf	desitky,W
	call	hex2ascii
	movwf	TMP1			;uschovej low byte
	movf	TMP,W			;nacti vyssi
	call	send			;posli ho
	movf	TMP1,W			;nacti nizsi zpet
	call	send			;posli ho
	movlw	0DH				;ENTER
	call	send
	return
;-------------------------------


;-----------------------------Ukoncujici prikaz----------
ukonci
	movlw	1AH
	call	send
	return


;-----------------------------Format dat bude PDU------------
prikazCMGF
	movlw	'a'
	call	send
	movlw	't'
	call	send
	movlw	'+'
	call	send
	movlw	'c'
	call	send
	movlw	'm'
	call	send
	movlw	'g'
	call	send
	movlw	'f'
	call	send
	movlw	'='
	call	send
	movlw	'0'
	call	send
	movlw	0DH		;ENTER
	call	send
	return
;-------------------------------


bin2dec
	clrf     TMP
	clrf	stovky
	clrf	desitky
opet_1
	addlw    -64H
	btfss     STATUS,C
	goto	dalsi_rad
	incf		stovky, F
	goto	opet_1
dalsi_rad
	addlw    100
opet
	addlw    -10
	btfss     STATUS,C
	goto    swapTMP
	incf     desitky, F
	goto    opet
swapTMP
	addlw    10
	swapf    desitky, F
	iorwf     desitky, F
	return

;vraci vyssi v TMP, nizsi ve W
hex2ascii
        MOVWF   TMP ; save byte temporarily
        SWAPF   TMP,W       
        ; convert top nibble
        CALL    CONV_NIBBLE_HEX 
        ; top nibble in w, exchange char_hi with w
        XORWF   TMP,F
        XORWF   TMP,W
        XORWF   TMP,F
        ; and convert low nibble
CONV_NIBBLE_HEX
        ANDLW   0x0F    ; mask out top nibble, preserv low nibble
        ADDLW   0xF6    ; add 246, to check if 0-9 or a-f, w=nibble+246
        BTFSC   STATUS,C ; if carry set then a-f
        ADDLW   0x07     ; carry set, then add 7, w=nibble+246+7 ( note nibble known to be a-f )
        ADDLW   0x3A     ; then finally add 58 to get 'proper' ascii 
                        ; 1) w = low(nibble+246+58) = 48+nibble ( if 0-9 )
                        ; 2) w = low(nibble+246+7+58) = 55+nibble ( if a-f )
        ; nibble converted to ASCII hex in w            
        RETURN

; -----------------------------Odesle byte pres UART--------------------------------
;
send    movwf TXREG             ; send data in W 
TransWt bsf STATUS,RP0		; RAM PAGE 1
WtHere  btfss TXSTA,TRMT        ; (1) transmission is complete if hi
        goto WtHere

        bcf STATUS,RP0          ; RAM PAGE 0
        return

;------------------casovaci rutina---------1 sec.
cekame_1	
;Delay 1000000 cycles
        MOVLW 0x15  ;21 DEC
        MOVWF cas2
        MOVLW 0x59  ;89 DEC
        MOVWF cas1
        MOVLW 0x0B1  ;177 DEC
        MOVWF cas0
        DECFSZ cas0,F
        GOTO $-1
        DECFSZ cas1,F
        GOTO $-5
        DECFSZ cas2,F
        GOTO $-9
		return
  
        END

